--这个文件包含了代码量较大的API
GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})
local change = GLOBAL.PUELLA_MOD_FN.Change
local restore = GLOBAL.PUELLA_MOD_FN.Restore
------------------------------

-------玩家可以免疫影怪/闪光----
local function ShadowMonsterPostInit(inst)
    inst:AddTag('homura: lightshock immue') --不会被闪光弹消除仇恨
    inst:ListenForEvent('homura: lightshock',function(inst)
        if inst.components.health and not inst.components.health:IsDead()then
            inst.components.combat:GetAttacked(GetPlayer(),50)
        end
    end)
    --[[
    local notags = inst.components.combat.notags or {}
    table.insert(notags,'sayaka_inshadow')
    inst.components.combat.notags = notags

    inst:ListenForEvent('attacked',function(inst,data)
        if data and data.attacker == GetPlayer() then
            RemoveByValue(inst.components.combat.notags, 'sayaka_inshadow')
            inst.components.combat:SetTarget(GetPlayer())
        end
    end)

    
    inst:DoPeriodicTask(1,function(inst)
        if inst.components.combat.target == GetPlayer() and GetPlayer():HasTag('sayaka_inshadow')
            and table.contains(inst.components.combat.notags, 'sayaka_inshadow') then
            inst.components.combat.target = nil
        end
    end)
    --]]
end

for _,v in pairs({'ancient_herald','crawlinghorror','terrorbeak','crawlingnightmare','nightmarebeak','swimminghorror'})do
    AddPrefabPostInit(v, ShadowMonsterPostInit)
end

AddPrefabPostInit('shadowhand_arm',function(inst)
    inst:ListenForEvent('homura: lightshock',function(inst)inst:PushEvent('enterlight')end)
end)

AddPrefabPostInitAny(function(inst)
    local old_killed = inst.components.combat and inst.components.combat.onkilledbyother
    if old_killed then
        inst.components.combat.onkilledbyother = function(...)
            if not inst.components.health:IsDead() then
                return
            end
            old_killed(...)
            inst.components.combat.onkilledbyother = nil
        end
    end
end)

-------复活逻辑-------
local function resurrectionstatue(inst)
    local function onbuilt()
        local AVOIDSTATUE = GLOBAL.PUELLA_MOD_STRINGS:Get(GetPlayer().prefab,"CANNOT_REVIVE_1")
        GetPlayer().components.talker:StopIgnoringAll()
        GetPlayer().components.talker:Say(AVOIDSTATUE,4) 
    end 
    if GetPlayer().components.deadtimer then
        inst.components.resurrector.penalty = 0 
        inst:ListenForEvent( "onbuilt", function () inst:DoTaskInTime(.5,onbuilt) end)
    end
end
AddPrefabPostInit("resurrectionstatue",resurrectionstatue)
local function resurrectionstone(inst) 
    local old_OnActivate = inst.components.activatable.OnActivate 
    inst.components.activatable.OnActivate  = function(inst)
    old_OnActivate(inst)
    if GetPlayer().components.deadtimer then
        local AVOIDSTONE = GLOBAL.PUELLA_MOD_STRINGS:Get(GetPlayer().prefab,"CANNOT_REVIVE_2")
        GetPlayer().components.talker:StopIgnoringAll()
        GetPlayer().components.talker:Say(AVOIDSTONE,4)    
    end
    end
end
AddPrefabPostInit("resurrectionstone",resurrectionstone)
local function lifeflowerseed(inst)
    if not GetPlayer().components.deadtimer then
        return
    end
    local AVOIDFLOWER = GLOBAL.PUELLA_MOD_STRINGS:Get(GetPlayer().prefab,"CANNOT_REVIVE_3")
    local old_ondeploy = inst.components.deployable.ondeploy 
    inst.components.deployable.ondeploy = function (inst,pt)
         old_ondeploy(inst,pt)
         GetPlayer().components.talker:StopIgnoringAll()
         GetPlayer().components.talker:Say(AVOIDFLOWER,4) 
    end 
end   
local function lifeflower(inst)
    if GetPlayer().components.deadtimer then
        inst.components.resurrector.penalty = 0
    end
end
AddPrefabPostInit("waterdrop",lifeflowerseed)
AddPrefabPostInit("lifeplant",lifeflower)

local function beachresurrector(inst)
    inst:DoTaskInTime(0,function()
        SpawnPrefab("beachresurrector_magic").Transform:SetPosition(inst:GetPosition():Get())
    end)
end
AddPrefabPostInit("beachresurrector",beachresurrector)


local function poisonable_postinit(Poisonable)
    local function ImmunityOver(inst)
        local poisonable = inst.components.poisonable
        if poisonable then
            poisonable.immune = false
            poisonable:KillFX()
        end
    end

    function Poisonable:Sayaka_Cure(immuetime)
        self:DonePoisoning()
        if self.oncured then
            self.oncured()
        end
        if immuetime then
            if self.immunetask then
            self.immunetask:Cancel()
            end
            self.immune = true
            self.immunetask = self.inst:DoTaskInTime(immuetime, ImmunityOver)
        end
    end
end
AddComponentPostInit("poisonable",poisonable_postinit)
--[[
function GLOBAL.PUELLA_MOD_FN.Sayaka_GetSpeedAdditive(self)
    local add_modifiers = 0
    for k,v in pairs(self.speed_modifiers_add) do
        add_modifiers = add_modifiers + math.max(v,0)
    end
    return add_modifiers
end

function GLOBAL.PUELLA_MOD_FN.Sayaka_GetSpeedMultiplier(self)
    local wind_speed = 1
    local sm = GetSeasonManager()

    local mult_modifiers = 1

    for k,v in pairs(self.speed_modifiers_mult) do
        mult_modifiers = mult_modifiers + math.max(v,0)
    end

    local slowingObjectsmmultiplier = 1
    --return self.groundspeedmultiplier * wind_speed * self.throttle * mult_modifiers * slowingObjectsmmultiplier
    return self.groundspeedmultiplier * self.throttle * mult_modifiers 
end
    
function GLOBAL.PUELLA_MOD_FN.Sayaka_UpdateGroundSpeedMultiplier(self)
    self.groundspeedmultiplier = 1
    local ground = GetWorld()
    local x,y,z = self.inst.Transform:GetWorldPosition()
    if RoadManager and RoadManager:IsOnRoad( x,0,z ) then
        self.groundspeedmultiplier = self.fastmultiplier
    elseif ground ~= nil then
        local tile = ground.Map:GetTileAtPoint(x,0,z)       
        if tile and tile == GLOBAL.GROUND.ROAD then
            self.groundspeedmultiplier = self.fastmultiplier
        end
    end
end
--]]

local function vaccumpostinit(Vaccum)
    
function Vaccum:OnUpdate(dt)
    -- find entities within radius and vacuum them towards my location  
    local pt = self.inst:GetPosition()
    local ents = TheSim:FindEntities(pt.x, 0, pt.z, self.consumeradius, nil, self.noTags)

    for k,v in pairs(ents) do
        if v and v.components.inventoryitem and not v.components.inventoryitem:IsHeld() then
            if not self.inst.components.inventory:GiveItem(v) then
                self:SpitItem(v)
            end 
        end 
    end

    ents = TheSim:FindEntities(pt.x, pt.y, pt.z, self.vacuumradius, nil, self.noTags)

    for k,v in pairs(ents) do
        if v and v.Physics and v.components.inventoryitem and not v.components.inventoryitem:IsHeld() and CheckLOSFromPoint(self.inst:GetPosition(), v:GetPosition()) then
            local x, y, z = v:GetPosition():Get()
            y = .1
            v.Physics:Teleport(x,y,z)
            local dir =  v:GetPosition() - self.inst:GetPosition()
            local angle = math.atan2(-dir.z, -dir.x) 
            v.Physics:SetVel(math.cos(angle) * self.vacuumspeed, 0, math.sin(angle) * self.vacuumspeed)
        else
            v:AddTag("NOVACUUM")
            v:DoTaskInTime(1, function() v:RemoveTag("NOVACUUM") end)
        end
    end 

    if not self.ignoreplayer or self.vacuuming_player then 
        local player = GetPlayer()
        if player:HasTag("twister_immue")then
            return
        end
        local playerpos = player:GetPosition()
        local displacement = playerpos - self.inst:GetPosition()  
        local dist = displacement:Length()
        local angle = math.atan2(-displacement.z, -displacement.x) 
        local windProofness = player.components.inventory:GetWindproofness()
        --Allow the player to get closer if they're wearing something with windproofness
        local playerDistanceMultiplier =  1 - (windProofness * 0.25)
        if dist < self.player_hold_distance or self.spitplayer then
            --hold player inside
            self.holdingplayertimer = self.holdingplayertimer + dt

            if not self.spitplayer then 
                player.Transform:SetRotation(0) 
                player.Physics:SetMotorVelOverride(0, 0, 0)
                player:PushEvent("vacuum_held")
            else 
                local mult = self.playervacuumdamage / self.inst.components.combat.defaultdamage
                self.inst.components.combat:DoAttack(player, nil, nil, nil, mult)
                player.components.sanity:DoDelta(self.playervacuumsanityhit )
                player:AddTag("NOVACUUM") --Shoot player out 
                player:PushEvent("vacuum_out", {angle = angle, speed = -self.vacuumspeed})
                player.Transform:SetRotation(0) 
                self.holdingplayertimer = 0
                self.vacuuming_player = false 
            end 
        
        elseif not player:HasTag("NOVACUUM") and (self.vacuuming_player or (dist < (self.playervacuumradius * playerDistanceMultiplier) and CheckLOSFromPoint(self.inst:GetPosition(), player:GetPosition()))) then 
            --print("trying to vacuum in the player")

            player.Transform:SetRotation(0) 
            player.Physics:SetMotorVelOverride(math.cos(angle) * self.vacuumspeed, 0, math.sin(angle) * self.vacuumspeed)
            player.components.locomotor:Clear()
            player:PushEvent("vacuum_in")
            self.holdingplayertimer = 0
            self.vacuuming_player = true
        end 
    end 

    self.spitplayer = false
end
end

--AddComponentPostInit("vacuum",vaccumpostinit) --可以免疫风季boss的风力


local transparent_prefabs = {"raindrop","wave_shimmer","wave_shimmer_med","wave_shimmer_deep","wave_shimmer_flood",
    "wave_shore","impact","shatter",}
for _,v in pairs(transparent_prefabs)do
    AddPrefabPostInit(v,function(inst) inst:AddComponent("to_be_transparent")end)
end

local ignoretimemagic_prefabs = {"rowboat_wake","dyc_damagedisplay",}
for _,v in pairs(ignoretimemagic_prefabs)do
    AddPrefabPostInit(v,function(inst) inst:AddTag("ignoretimemagic") end)
end

local function throwpostinit(throwable)
    local old_throw = throwable.Throw
    function throwable:Throw(...)
        self.inst:PushEvent("throw")
        old_throw(self,...)
    end
end
AddComponentPostInit("throwable",throwpostinit)

local function healthpostinit(health)
    if not health.DoPoisonDamage then
        function health:DoPoisonDamage(amount, doer)
            if not self.invincible and self.vulnerabletopoisondamage and self.poison_damage_scale > 0 then
                if amount > 0 then
                    self:DoDelta(-amount*self.poison_damage_scale, false, "poison")
                end
            end
        end
    end
end   
AddComponentPostInit("health",healthpostinit)

local function moisturepostinit(self)
    local old_get = self.GetDelta
    function self:GetDelta(...)
        if GetWorld():HasTag('homuraTag_pause') then
            return 0
        else
            return old_get(self, ...)
        end
    end
end
AddComponentPostInit('moisture',moisturepostinit)

--时停期间被击杀, 仍然可作为攻击目标
--时停前被击杀, 无法被攻击
AddPrefabPostInitAny(function(inst)
    if not inst:HasTag('player') and not inst:HasTag('character') then
        inst:ListenForEvent('death', function()
            if not inst:HasTag('homuraTag_pause') then
                inst:AddTag('homura: die before tp') 
            end
        end)
    end
end)

local function clockpostinit(clock)
    clock.inst:ListenForEvent('nighttime',  function() clock.puella_mod_timescale = nil end)
    clock.inst:ListenForEvent('daytime',    function() clock.puella_mod_timescale = nil end)
    
    local old_OnUptate = clock.OnUpdate
    function clock:OnUpdate(dt)
        old_OnUptate(self, dt*(self.puella_mod_timescale or 1))
    end

    local old_save = clock.OnSave
    function clock:OnSave()
        local data = old_save(self)
        data.puella_mod_timescale = self.puella_mod_timescale
        return data 
    end

    local old_load = clock.OnLoad
    function clock:OnLoad(data)
        old_load(self, data)
        self.puella_mod_timescale = data.puella_mod_timescale
    end
end
AddComponentPostInit("clock",clockpostinit)

local function combatpostinit(combat)

    local function IsBack(attacker, target)
        if target:IsValid() and target.Transform and attacker:IsValid() and attacker.Transform then
            local angle1 = target.Transform:GetRotation()
            local angle2 = target:GetAngleToPoint(attacker:GetPosition())
            local deltaangle = PUELLA_MOD_FN.DeltaAngle(angle1,angle2,true)
            if deltaangle > 100 then
                return true
            elseif deltaangle > 80 and math.random() < 0.75 then
                return true
            end
        end
    end     

    local old_settarget = combat.SetTarget
    function combat:SetTarget(new, ...)
        if new and new:HasTag('homura: has silencer') and IsBack(new, self.inst) then
            return
        else
            return old_settarget(self, new, ...)
        end
    end

    local old_share = combat.ShareTarget
    function combat:ShareTarget(target, ...)
        if target and target:HasTag('homura: has silencer') and IsBack(target, self.inst) then
            return
        else
            return old_share(self, target, ...)
        end
    end

    local inst = combat.inst
    inst:AddComponent('kyouko_hurt_debuff')
    inst:AddComponent('sayaka_darkness_debuff')
    inst:AddComponent('witchsd_darkness_debuff')
end
AddComponentPostInit("combat",combatpostinit)

--在一定程度上防止玩家利用时间停止机制刷淘气值
local function krampedpostinit(self)
    local old_onkilledother = self.onkilledother
    function self:onkilledother(...)
        if self.inst.components.skill_homura and not self.inst.components.skill_homura:IsKrampedEnabled() then
            return 
        else
            return old_onkilledother(self, ...)
        end
    end
end
AddComponentPostInit("kramped",krampedpostinit)

local function invpostinit(c) ---DLC0003
    local old_equip = c.Equip 
    function c:Equip(item, old_to_active,...)
        if not item or not item.components.equippable or not item:IsValid() then
            return
        end

        local eslot = item.components.equippable.equipslot
        local olditem = eslot and self:GetEquippedItem(eslot)
        --print(eslot,olditem)
        if olditem and olditem.components.equippable.un_unequipable then
            self.inst:PushEvent("cantequip", {item=item, eslot=eslot,olditem=olditem })
            return
        end
        -------
        return old_equip(self,item,old_to_active,...)
    end

    local old_dropitem = c.DropItem
    function c:DropItem(item,...)
        if not item or not (item.components.inventoryitem and item.components.inventoryitem.candrop) or item:HasTag("cantdrop") then
            return
        end
        -------
        return old_dropitem(self,item,...)
    end
end

AddComponentPostInit('inventory', invpostinit)

local function IgnoreArmor(armor) 
    local old_can = armor.CanResist
    function armor:CanResist(attacker, weapon, ...)
        if (attacker and attacker:HasTag('canignorearmor')) or (weapon and weapon:HasTag('canignorearmor')) then
            return false
        else
            return old_can(self, attacker, weapon, ...)
        end
    end
end

AddComponentPostInit('armor', IgnoreArmor)

local function FreezablePostInit(freezable)
    local old_freeze = freezable.Freeze
    function freezable:Freeze(...)
        if self.is_freeze_immue then
            return
        else
            return old_freeze(self, ...)
        end
    end
end

AddComponentPostInit('freezable', FreezablePostInit)

local function ExplosivePostInit(explosive)
    local old_onburnt = explosive.OnBurnt
    function explosive:OnBurnt(...)
        local pos = self.inst:GetPosition()
        local redirect = self.redirect_to_player
        local radius = self.explosiverange
        old_onburnt(self, ...)
        if redirect then
            local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, radius, {'combat'}, {'INLIMBO'})
            for k,v in pairs(ents) do
                if v.components.combat and v ~= self.inst then
                    v:PushEvent('attacked',{damage = 0, attacker = GetPlayer()})
                end
            end
        end
    end  
end

AddComponentPostInit('explosive', ExplosivePostInit)

local function UnwrapPostInit(unwrappable)
    local old_wrap = unwrappable.WrapItems
    function unwrappable:WrapItems(items, doer, ...)
        for _, v in pairs(items or {})do
            if v.prefab == 'griefseed' or v.prefab == 'cookedgriefseed' then
                if GetPlayer().components.witchspawner then
                    GetPlayer().components.witchspawner:AddGS()
                end
            end
        end
        return old_wrap(self, items, doer, ...)
    end
    --[[
    local old_unwrap = unwrappable.Unwrap
    function unwrappable:Unwrap(doer, ...)
        for _, v in pairs(self.itemdata or {})do
            if v.prefab == 'griefseed' or v.prefab == 'cookedgriefseed' then
                if GetPlayer().components.witchspawner then
                    GetPlayer().components.witchspawner:RemoveGS()
                end
            end
        end
        return old_unwrap(self, doer, ...)
    end
    --]]
    local old_remove = unwrappable.OnRemoveEntity
    function unwrappable:OnRemoveEntity(...)
        if old_remove then
            old_remove(self, ...)
        end
        for _, v in pairs(self.itemdata or {})do
            if v.prefab == 'griefseed' or v.prefab == 'cookedgriefseed' then
                if GetPlayer().components.witchspawner then
                    GetPlayer().components.witchspawner:RemoveGS()
                end
            end
        end
    end
    --> 被坎普斯偷走 --> itemdata内有数据 --> 种子数量减少
    --> 被打开 --> itemdata为nil --> 种子数量不变
    --> 被烧毁 --> ? --> 种子数量不变
end

AddComponentPostInit('unwrappable', UnwrapPostInit)


