local HomuraBuild = Class(function(self, inst)
    self.inst = inst
    --self.inst:DoTaskInTime(0,function()self:ModTechTree()end)
    self.inst:StartUpdatingComponent(self)    
    self.level = 0
end)
--[[
local function ModBuilder(builder)  --用显示和隐藏ui的方法强制保证原型机的控制能力。（参考DLC0003）
    local old_EvaluateTechTrees = builder.EvaluateTechTrees
    function builder:EvaluateTechTrees(...)
        old_EvaluateTechTrees(self,...)
        local controls = GetPlayer().HUD.controls
        for k,v in pairs(controls.crafttabs.tabs.tabs)do
            if v.tooltip == PUELLA_MOD_STRINGS.HOMURA_TAB then
                if self.inst.components.homura_build.canbuild then
                    controls.crafttabs.tabs:ShowTab(v)
                else
                    controls.crafttabs.tabs:HideTab(v)
                    local fn = controls.crafttabs.crafting.filter
                    if fn and fn('homura_bombs_flash') and controls.crafttabs.crafting.open then
                        controls.crafttabs.crafting:Close()
                        controls.crafttabs.tabs:DeselectAll()
                    end
                end
            end
        end
    end
end
--]]
local function UpdatePlayerTechTree(level) --这个操作可千万别放联机
    local recipes = GetAllRecipes(true)
    for k,rec in pairs(recipes)do
        if rec.tab and rec.tab.str == 'HOMURA_1' and rec.level.HOMURA_WEAPON then
            if rec.level.HOMURA_WEAPON <= level then
                rec.level.SCIENCE = 0
            else
                rec.level.SCIENCE = 10
            end
        end
    end
end

function HomuraBuild:ModTechTree() 
    --ModBuilder(self.inst.components.builder)
end

function HomuraBuild:OnUpdate(dt)
    local level = 0
    local radius = TUNING.RESEARCH_MACHINE_DIST
    local x,y,z = self.inst:GetPosition():Get()
    local ents = TheSim:FindEntities(x,y,z, radius,{"homura_prototyper"})
    for _,v in pairs(ents)do
        if v:GetLevel() == 1 then
            level = 1
        elseif v:GetLevel() == 2 then
            level = 2
            break
        end
    end
    if level ~= self.level then
        self.inst:PushEvent("techtreechange",{homura_weapon_level=level})
        UpdatePlayerTechTree(level)--模拟科技树效果
        self.level = level
    end
end

function HomuraBuild:GetDebugString()
    return tostring(self.level)
end

return HomuraBuild
