local Skill = Class(function(self, inst)
    self.inst = inst
end)

function Skill:CanLunge(pos)
	if self.inst.components.driver and self.inst.components.driver:GetIsDriving() then
		return false
	end
	local tile = GetWorld() and GetWorld().Map:GetTileAtPoint(pos:Get())
	if tile == GROUND.IMPASSIBLE then
		return false
	end
	if not GetPlayer().components.skill_sayaka or not GetPlayer().components.skill_sayaka:CanLunge() then
		return false
	end

	do
		return true
	end
end

function Skill:CollectPointActions(doer, pos, actions, right)
    if right then
		if self:CanLunge(pos) then
			table.insert(actions, ACTIONS.SAYAKA_LUNGE)
		end
	end
end

function Skill:CollectEquippedActions(doer, target, actions, right)
	if right and self:CanLunge(target:GetPosition()) then
		table.insert(actions, ACTIONS.SAYAKA_LUNGE)
	end
end


return Skill
