local skill_kyouko_sweep = Class(function(self, inst)
    self.inst = inst
    self.cansweep = false
    self.atks = 0
    self.min = 3
    
    inst:ListenForEvent('onhitother',function(i,data)self:OnHitOther(data)end)
end)

local function CreateRing()
	local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local snd = inst.entity:AddSoundEmitter()
    PUELLA_MOD_FN.SetAnim(inst,"griefseed_fx","griefseed_fx","blast",false,true)

    trans:SetScale(1.5,1.5,1.5)

    inst:ListenForEvent("animover",inst.Remove)   

    return inst
end

function skill_kyouko_sweep:OnSweep() ---生成特效
	self.cansweep = false
	self.atks = 0
	--local rate = self.inst.components.soulgem.rate/2  --(0.5~1.5)/2
	--self.inst.components.soulgem:DoDelta(rate)
	self.inst.components.hunger:DoDelta(-1)
	self.inst:DoTaskInTime(.45, function() 
		CreateRing().Transform:SetPosition(self.inst:GetPosition():Get())
	end)
end

function skill_kyouko_sweep:CanSweep() 
	return self.cansweep and self.inst.components.hunger.current > 50 and self:ForceAttackEnabled()
	
end

function skill_kyouko_sweep:ForceAttackEnabled()
	if TheInput:IsControlPressed(CONTROL_PRIMARY) then
		return true
	end
	--if TheInput:IsControlPressed(CONTROL_ATTACK) or TheInput:IsControlPressed(CONTROL_CONTROLLER_ATTACK) then
		if TheInput:IsControlPressed(CONTROL_FORCE_ATTACK) then
			return true
		end
	--end

	return false
end

function skill_kyouko_sweep:OnHitOther(data)
	local weapon = self.inst.components.combat:GetWeapon()
	if not weapon or weapon.prefab ~= 'kyouko_spear' then
		return
	end
	if data and data.stimuli == 'kyouko_sweep' or data.stimuli == 'kyouko_hurt' then
		return
	end
	self.atks = self.atks + 1
	if self.atks >= self.min then
		self.cansweep = true
	end
end

return skill_kyouko_sweep
