local assets=  ----剪刀飞啊飞
{
    Asset("ANIM", "anim/qw_projectile.zip"),
    --Asset("SOUND", "sound/chess.fsb"),
}

local function OnHit(inst, owner, target)
    inst:Remove()
    --inst.SoundEmitter:PlaySound("dontstarve/creatures/bishop/shotexplo")
end

local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    --inst.Transform:SetFourFaced()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    
    MakeInventoryPhysics(inst)
    --inst.Physics:SetRestitution(1)
    RemovePhysicsColliders(inst)

    trans:SetScale(.8,.8,.8)
    
    anim:SetBank("qw_projectile")
    anim:SetBuild("qw_projectile")
    anim:PlayAnimation("anim",true)
    
    inst:AddTag("projectile")
    inst.persists = false
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(2)
    inst.components.projectile:SetLaunchOffset(Vector3(0,1,0))
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnHit)

    
    return inst
end

return Prefab( "common/inventory/qw_projectile", fn, assets) 