--[[
local function split(word,i) --输入字符串和分割点，返回分割后的两个字符串
    
    local a = word:sub(1,i)
    local b = word:sub(i+1)
    return a,b 
end

local function FindAndSplitAfter(str1,key) ---在关键词前分割
    
    if not str1 then
        return false
    end
    
    local i = str1:find(key)
    if i then
        local a,b = split(str1,i+key:len())
        return a,b 
    else
        return false
    end
end

local function FindAndSplitBefore(str1,key) ---在关键词后分割
    local i = str1:find(key)
    if i then
        local a,b = split(str1,i)
        return a,b
    else
        return false
    end
end
--]]



--新手福利
--用于将一行未加密的mod代码重排
local str_ori =[[]]

local str = 'lw:\n'

local keywords = {["end "]=1,["do "]=1,[") "]=1,["else "]=1,["elseif "]=1,["; "]=1,[' if']=2,[' local']=2}

local loop = 0
while string.len(str_ori) >= 10 and loop <10000 do
	local i = string.len(str_ori)
	local word = ''
	local before_or_after = 1
    for k,v in pairs(keywords)do   ---k 关键词   v 词前分割还是词后分割
    	local thisi = str_ori:find(k) 
    	if thisi and thisi < i then
    		i = thisi
    		word = k  ----寻找最近的一个关键词
    		--if v == 2 then before_or_after = 2 else before_or_after = 1 end
    	end
    end
    if word == '' then
    	break
    end
    if word ~= ' if' and word~= ' local' then
    	i = i+word:len()-1
    else
    	--i = i-1
    end

    local a,b = str_ori:sub(1,i),str_ori:sub(i+1)
    str = str..'\n'..a
    str_ori = b
    loop = loop+1
end
print(str..str_ori)