--[[
local function DoAddClassPostConstruct(classdef, postfn)
    local constructor = classdef._ctor
    classdef._ctor = function (self, ...)
        constructor(self, ...)
        postfn(self, ...)
    end
    local mt = getmetatable(classdef)
    mt.__call = function(class_tbl, ...)
        local obj = {}
        setmetatable(obj, classdef)
        if classdef._ctor then
            classdef._ctor(obj, ...)
        end
        return obj
    end
end
--]]
--require 'mods'
local old_re = ModManager.RegisterPrefabs
function ModManager:RegisterPrefabs(...)
    if not (GetModConfigData('language') == "AUTO") then
            GLOBAL.PUELLA_MOD_SETTINGS.LANGUAGE = (GetModConfigData('language') == 'ENG')
        else
            GLOBAL.PUELLA_MOD_SETTINGS.LANGUAGE = (STRINGS.CHARACTER_NAMES.wendy == 'Wendy')
        end
        print('RUN')
        --assert(false)
        print('LANGUAGE IS ' .. tostring(PUELLA_MOD_SETTINGS.LANGUAGE):upper())
        GLOBAL.PUELLA_MOD_FN.SetCharData(PUELLA_MOD_SETTINGS.LANGUAGE)

    old_re(self, ...)
end
do return end
