local L = GLOBAL.PUELLA_MOD_SETTINGS.LANGUAGE 
local K = GLOBAL.PUELLA_MOD_SETTINGS.CHARGEKEY
GLOBAL.PUELLA_MOD_STRINGS = {}
local str = GLOBAL.PUELLA_MOD_STRINGS

--禁用复活装置
str.CANNOT_REVIVE_1 = L and 
{
    kyouko = {"Its magical power is not compatible with mine.",},
    homura_1 = {"Our magical girls are not human, so it won't function."},
    sayaka = {"My soul gem can protect me."}
}
or
{
    kyouko = {"奇怪了，这个雕像的魔法和我不兼容。",},
    homura_1 = {"一旦灵魂被束缚，这个魔法器就没有作用了。"},
    sayaka = {"我的灵魂宝石可以保护我。"},
}

str.CANNOT_REVIVE_2 = L and 
{
    kyouko = {"Its magical power is not compatible with mine.",},
    homura_1 ={"This magical stone is unavailable if the soul is bound.",}, 
    sayaka = {"My healing magic is extraordinarily powerful, so I don't need it."},
}
or
{
    kyouko = {"我的灵魂宝石会排斥这个祭坛蕴含的魔力。",},
    homura_1 = {"我们魔法少女不是人类，所以这个装置不会起效。"},
    sayaka = {"我的治疗术很强大，所以好像并不需要这东西。"},
}

str.CANNOT_REVIVE_3 = L and
{
    kyouko = {"Its magical power is not compatible with mine.",},
    homura_1 = {"At least it's a nice decoration."},
    sayaka = {"Now the only thing for me is to get enough food."},
}
or
{
    kyouko = {"这花看起来挺漂亮的，但没什么实际用处啊。"},
    homura_1 = {"至少... 它还能用于观赏。"},
    sayaka = {"现在，只要有足够的食物，我就无敌了~"},
}

--复活
str.RESURRECT_SEA = L and 
{
    kyouko = { "Let's go! No time to hesitate!",}, 
    sayaka = {"That was so dangerous..."},
    homura_1 = {"It was a simple teleporting magic."},
    -- "My soul gem became turbid.",
}
or
{
    kyouko = {"出发！没什么大不了的。"},
    sayaka = {"刚才好险啊..."},
    homura_1 = {"这是一个简单的传送魔法。"},
}

str.RESURRECT = L and
{
    kyouko = {"Oh, I slipped up."},
    sayaka = {"I should be careful."},
    homura_1 = {"There is still a little bit benefit after being a magical girl."},
}
or
{
    kyouko = {"刚才失手了。"},
    sayaka = {"果然还是不能掉以轻心呢。"},
    homura_1 = {"成为魔法少女还是有那么一点点好处的。"},
}

--boss警告
str.WITCH_LOST = L and
{
    kyouko = {"I missed it."},
}
or 
{
    kyouko = {"切，跟丢了..."},
    sayaka = {"哎呀，魔女不见了，下次加油吧"},
    homura_1 = {"下次再来收拾你"},
}
str.WITCH_APPEAR = L and 
{
    kyouko = {"The prey is appearing."},
    sayaka = {"Those evil guys come again."},
    homura_1 = {"A witch approaches."},
}
or 
{
    kyouko = {"我的猎物出现了。"},
    sayaka = {"那些邪恶的家伙又来了。"},
    homura_1 = {"来了。"},
}
str.WITCH_FAR1 = L and 
{
    kyouko = {"I'm going a little bit off."}
}
or
{
    kyouko = {"不在这儿，换个方向吧。"},
    sayaka = {"方向...稍微偏了一点。"},
    homura_1 = {"方向不对，我得换条路。"},
}
str.WITCH_FAR2 = L and
{
    kyouko = {"The smell of the target is fading."}
}
or
{
    kyouko = {"猎物的气息越来越淡了。"},
    sayaka = {"我感觉我和魔女的距离在变大..."},
    homura_1 = {"魔力反应变微弱了。"},

}
str.WITCH_FAR3 = L and
{
    kyouko = {"Concentrate! Or the witch will disappeare!"}
}
or
{
    kyouko = {"喂！再走远一点魔女就要跑了！"},
    sayaka = {"我好像已经离魔女很远了..."},
    homura_1 = {"魔力反应已经快接近消失了。"},
}
str.WITCH_VERYFAR_FAR = L and
{
    kyouko = {"Concentrate! Or the witch will disappeare!"}
}
or
{
    kyouko = {"魔女应该还在，但灵魂宝石已经探测不到她的魔力了"},
    sayaka = {"和魔女的距离实在是太大了，灵魂宝石没有任何反应"},
    homura_1 = {"我的宝石不再闪烁..."},
}
str.WITCH_VERYFAR_NEAR = L and
{
    kyouko = {"Concentrate! Or the witch will disappeare!"}
}
or
{
    kyouko = {"哈哈，我又发现你了!"},
    sayaka = {"虽然很微弱，但灵魂宝石在发光!"},
    homura_1 = {"还有机会"},
}

str.WITCH_NEAR1 = L and
{
    kyouko = {"Here!"},
}
or
{
    kyouko = {"我等不及了！"},
    sayaka = {"她就在附近。"},
    homura_1 = {"做好准备，要开打了。"},
}
str.WITCH_NEAR2 = L and
{
    kyouko = {"I can feel that I'm getting closer to my prey."},
    sayaka = {"The direction is right."},
    homura_1 = {"The magic reaction is becoming stronger."},
}
or
{
    kyouko = {"我能感觉到，我离猎物越来越近了。"},
    sayaka = {"方向应该是对的。"},
    homura_1 = {"魔力反应变强了。"},
}

str.SD_TIMEMAGIC = L and 
{
    kyouko = {"It's time magic!",},
}
or
{
    kyouko = {"听起来不妙啊!"},
    sayaka = {"她在控制时间"},
    homura_1 = {"这是和我非常类似的魔法"},
}

--死亡警告
str.DIELINES = 
{
    kyouko = L and 
        {
            {
            "The stories of love and justice don't exist in this world at all...",
            "Although I fought for others, nothing has changed by my efforts.",
            "I cannot even save... my dearest family...",
            "Now I have nothing but despair and resentment.",
            "I will curse this world!" ,
            "I will distroy everything in this world!!",
            },
            {
            "Magical girls are fated to become witches, to become foods for new magical girls.",
            "The one who eats others will finally be the one who is eaten.",
            "Ha ha ha... so will I...",
            "If hope is lost and despair is not withstood...",
            "The inevitable ending is to fall and become the prey.",
            "Now I understand you words, this is called... despair...",
            },
        }
        or
        {
            {
            "爱与正义的故事，在这个世界是根本不存在的...",
            "我不顾自己，为了别人而努力，结果却是这个结局。",
            "我都没法拯救...我最爱的家人...",
            "我的希望全都消失了...我已经什么都没有了！",
            "我要诅咒！我要诅咒这个世界上所有的一切！",
            "可恶！！！！",
            },
            {
            "魔法少女就是为了变成魔女，成为新的魔法少女的饵而存在的。",
            "这就是食物连锁，吃的一方，也终有一天会成为被吃的一方。",
            "哈哈哈...我也是...一样的...",
            "如果失去了希望，无法抵挡绝望的话...",
            "就只有堕落了，成为被捕食的一方。",
            "我终于明白了，你说的话。这就是...真正的绝望...",
            },
        },

    sayaka = L and 
        {
            {
            "I just can't care about anything anymore.",
            "I can't even remember what I thought was \nso important, so worth protecting...",
            "None of it makes sense anymore.",
            "Hope and despair balance back to zero...",
            "Yes, that's right...",
            "Now I get what that means.",
            },
            {
            "It's true that I've saved a few people.",
            "But in equal measure, my heart became \nfilled with resentment and hatred.",
            "So much so that I enen hurt my dearest friend.",
            "For as much happiness as we wish on one person,\nWe can't help but curse someone else.",
            "That's how it works for us magical girls.",
            "I was stupied... so stupied.",
            },
        }or
        {  
            {
            "我只是觉得已经什么都无所谓了。",
            "到头来我到底珍惜的是什么，又要保护什么...",
            "已经完全搞不清楚了。",
            "希望和绝望的平衡正负相抵",
            "那是对的...",
            "我现在已经能够深刻体会到了。",
            },
            {
            "虽然的确我也已经救了很多人了",
            "但相对的，心里也积累了怨恨和嫉妒",
            "还伤害了最重要的朋友",
            "祈求别人幸福的同时，却不得不去诅咒其他人",
            "我们魔法少女就是这样的构造吧",
            "我真是个笨蛋...",
            },
        },
    homura_1 = L and 
        {
            {
            'death alarm 1',
            'death alarm 2',
            'death alarm 3',
            'death alarm 4',
            'death alarm 5',
            'death alarm 6',
            },
            {
            'death alarm 1',
            'death alarm 2',
            'death alarm 3',
            'death alarm 4',
            'death alarm 5',
            'death alarm 6',
            },
        }or
        {
            {
            '灵魂宝石已经完全污染了',
            '无数次的尝试, 无数次的失败',
            '我还没有实现跟她的约定',
            '我还没有... 帮她从绝望的命运中逃脱...',
            '我... 我至今所做的一切',
            '到底是... 为了... 什么...',
            },
            {
            'death alarm 1',
            'death alarm 2',
            'death alarm 3',
            'death alarm 4',
            'death alarm 5',
            'death alarm 6',
            },
        },
}
str.FORCECHARGE = L and 
{
    kyouko = {"Wait a mimute."},
    sayaka = {"It's time to combat!"},

}
or 
{
    kyouko = {"再等等。"},
    sayaka = {"战斗还没结束呢！"},
    --homura_1 = {""}
}
str.SOULGEM_WARNING = L and 
{
    kyouko = {"I should purify my soul gem!"},
}
or
{
    kyouko = {'卧槽, 我的宝石怎么这么浑浊了?!'},
    sayaka = {'唔,有点...不舒服...'},
    homura_1 = {'灵魂宝石快达到极限了,要是再不净化的话..'}
}

str.RESCUE = L and
{
    kyouko = {"I pay too much, so it's time to follow my inclinations.",}, 
    sayaka = {"Cheer up!"},
    homura_1 = {"I can't give up!"},      
}
or
{
    kyouko = {"为了一个所谓的奇迹, 我付出了太多代价, 还是随心所欲地生活吧",},
    sayaka = {"嘿, 打起精神来！"},
    homura_1 = {"比毅力, 我是不会输的！"},

}

str.WITCH_HAS_ESCAPED = L and
{
    kyouko = {"Damn it! My prey disappeared.","It's a wise retreat."},
}
or
{
    kyouko = {"可恶，让它逃掉了！","状态不佳，撤退才是理智之举。"},
}

function GLOBAL.PUELLA_MOD_STRINGS:Get(player,situation,key)
    local strs = self[situation] and (self[situation][player] or self[situation].kyouko )
    if type(strs)=="nil" then
        return "NO STRING!"
    end
    if type(str)=="string" then
        return str
    end
    key = key or (#strs>0 and math.random(#strs))
    if not key then 
        return "NO STRING!"
    end

    local value = strs[key]
    if value then
        return value
    else
        return ""
    end
end

--作者：fenrir_sun 
--来源：CSDN 
--原文：https://blog.csdn.net/fenrir_sun/article/details/52232723 
--版权声明：本文为博主原创文章，转载请附上博文链接！
--[[
--返回当前字符实际占用的字符数
 function GLOBAL.PUELLA_MOD_STRINGS:GetByteCount(str, index)
    local curByte = string.byte(str, index)
    local byteCount = 1
    if curByte == nil then
        byteCount = 0
    elseif curByte > 0 and curByte <= 127 then
        byteCount = 1
    elseif curByte>=192 and curByte<=223 then
        byteCount = 2
    elseif curByte>=224 and curByte<=239 then
        byteCount = 3
    elseif curByte>=240 and curByte<=247 then
        byteCount = 4
    end
    return byteCount
end

--截取中英混合的UTF8字符串，endIndex可缺省
function GLOBAL.PUELLA_MOD_STRINGS:SubString(str, startIndex, endIndex)
    if startIndex < 0 then
        startIndex = self:GetTotalIndex(str) + startIndex + 1;
    end

    if endIndex ~= nil and endIndex < 0 then
        endIndex = self:GetTotalIndex(str) + endIndex + 1;
    end

    if not endIndex then 
        return string.sub(str, self:GetTrueIndex(str, startIndex))
    else
        return string.sub(str, self:GetTrueIndex(str, startIndex), self:GetTrueIndex(str, endIndex + 1) - 1)
    end
end

--获取中英混合UTF8字符串的真实字符数量
function GLOBAL.PUELLA_MOD_STRINGS:GetTotalIndex(str)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = self:GetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(lastCount == 0);
    return curIndex - 1;
end

function GLOBAL.PUELLA_MOD_STRINGS:GetTrueIndex(str, index)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = self:GetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(curIndex >= index);
    return i - lastCount;
end
--]]