local HomuraAmmo = Class(function(self, inst)
    self.inst = inst
end)

function HomuraAmmo:OnConsume(num)
    local instance = self.inst.components.stackable:Get(num)
    if instance then 
        instance:Remove()
    else
        self.inst:Remove()
    end
end

function HomuraAmmo:CollectUseActions(doer, target, actions)
    if target.components.homura_weapon and target.components.homura_weapon:CanAccept(self.inst) then
        table.insert(actions, ACTIONS.HOMURA_TAKEAMMO)
    end
end

return HomuraAmmo