local function CheckCanAbsorb(cause)
    if cause and cause == "kyouko_calc_return" then
        return false
    end
    if not cause then
        return true
    end
    local prefab = SpawnPrefab(cause)
    if not prefab then
        return false
    end
    local isattack = (not prefab.components.edible) and (prefab.components.combat or prefab.components.explosive)
    prefab:Remove()
    if isattack then
        return true
    else
        return false
    end
end

local function lockhealth(inst) 
    local old_DoDelta = inst.components.health.DoDelta
    function inst.components.health:DoDelta(amount,overtime,cause,ignore_invincible,skip_redirect)
        if self.redirect and not skip_redirect then
            self.redirect(self.inst, amount, overtime, cause)
            return
        end
        if not ignore_invincible and (self.invincible or self.inst.is_teleporting == true) then
            return
        end
        local _amount = amount
        if amount < 0 then
            amount = amount - (amount * self.absorb)
            local canlock = CheckCanAbsorb(cause) --判定伤害源是否为攻击
            local isdeadly = self.currenthealth + amount <= 0  --致命伤害
            local hasshield = self.inst.components.skill_kyouko:IsActivated() --有护盾情况下全部吸收
            local isavailable = self.inst.components.skill_kyouko:IsAvailable() --魔力充足并处于变身状态
            
            if canlock and isavailable and (hasshield or isdeadly) then
                _amount = self.inst.components.skill_kyouko:Calc(-amount) --剩余伤害由血量承担
                if _amount == 0 then
                    return
                end
            end        
        end 
        old_DoDelta(self,_amount,overtime,cause,ignore_invincible,skip_redirect)        
    end
end

return lockhealth