local MakeModPlayerCharacter = require "prefabs/player_common_mod"

local assets = {
    Asset("ANIM", "anim/sayaka.zip" ),
    Asset("ANIM", "anim/sayaka_heal.zip"),
}
local prefabs = {"griefseed","magicalboom_fx",}
local start_inv = {"griefseed",}
local createshadow = function(parent)
    local isdark = parent:HasTag('sayaka_dark')
    local inst,trans,anim,snd = PUELLA_MOD_FN.CreateEntity()
    trans:SetRotation(parent.Transform:GetRotation())
    trans:SetFourFaced()
    anim:SetBuild('sayaka_c') anim:SetBank('wilson')
    anim:SetPercent('lunge_pst',.5)

    local MultColour = isdark and {0,0,0,0.5} or {1,1,1,0.2}
    local MultColour2 = isdark and {0,0,0,0} or {1,1,1,0}
    local AddColour = isdark and {0,0,0,1} or {0,0.2,1,1}
    anim:SetMultColour(unpack(MultColour))
    inst:Hide();inst:DoTaskInTime(1/30,function()inst:Show();anim:SetAddColour(unpack(AddColour))end)
    
    inst.persists = false
    inst:AddTag('fx','NOCLICK','NOBLOCK')

    inst:AddComponent('colourtweener')
    inst.components.colourtweener:StartTween(MultColour2,0.5,inst.Remove)

    return inst
end

local fn = function(inst)
    inst.AnimState:SetBuild("sayaka")
    inst.soundsname = "willow"
    inst.MiniMapEntity:SetIcon( "sayaka.tex" )

    PUELLA_MOD_FN.MakeMagicalGirl(inst,{.5,.5,1,.5} ,nil,"近战兼远程（mod里不行）法师沙耶加")

    inst.components.health:SetMaxHealth(200)
    inst.components.hunger:SetMax(150)
    inst.components.sanity:SetMax(175)
    
    inst:AddComponent("skill_sayaka")
    inst:AddComponent("motionshadowspawner")
    inst.components.motionshadowspawner:Set({CreateEntity = createshadow,})

    local SGsayaka = require "stategraphs/SGmagicalgirls/SGsayaka"
    SGsayaka(inst)  

end
return MakeModPlayerCharacter("sayaka", prefabs, assets, fn, start_inv)
