local Text = require "widgets/text"
local Image = require"widgets/image"

local function UImode(sg)
sg:SetScale(1)
sg.mod = 1
sg.always_on_status = true

sg.pulse:SetScale(1)  --1.1   
sg.warning:SetScale(.9)  ---1  
sg.sg_uncharge:SetScale(.9)  ---1
sg.sg_charge:SetScale(.9)  ---1
sg.pulse_charge:SetScale(1)  ---1.1

sg.status_bg = sg:AddChild(Image("images/status.xml", "status.tex"))
sg.status_bg:SetScale(.37,.38,0)
sg.status_bg:SetPosition(0,-23,0)
--sg.status_bg:SetUVScale(0.1,0.1)

sg.max = sg:AddChild(Text(NUMBERFONT, 25))--soulgem最大值
sg.max:Hide()
sg.max:SetPosition(4, 0, 0)
sg.max:SetString("Max:\n"..tostring(sg.owner.components.soulgem.max))

sg.num:Show()
sg.num:SetPosition(3.5,-35,0)
sg.num:SetFont(NUMBERFONT)
sg.num:SetSize(28)
sg.num:SetScale(1,.78,1)
sg.num:MoveToFront()

for _,v in pairs({"hint","help","get_help"})do
	local pos = sg[v]:GetPosition()
	sg[v]:SetPosition(pos.x,pos.y-30,pos.z)
end

end

return UImode